import java.util.*;

class MCQN extends MCQ {

    MCQN (int n,boolean[][] A,int[] degree,int style) {
	super(n,A,degree, style);
    }
    
    void search(){
	cpuTime                              = System.currentTimeMillis();
	nodes                                = 0;
	colourClass                          = new ArrayList[n];
	ArrayList<Integer> C                 = new ArrayList<Integer>(n);
	ArrayList<Integer> P                 = new ArrayList<Integer>(n);
	ArrayList<Integer> N                 = new ArrayList<Integer>();
	for (int i=0;i<n;i++) colourClass[i] = new ArrayList<Integer>(n);
	orderVertices(P);
	expand(C, P, N);
    }

    void expand(ArrayList<Integer> C,ArrayList<Integer> P, ArrayList<Integer> N){
	if (timeLimit > 0 && System.currentTimeMillis() - cpuTime >= timeLimit) return;
	nodes++;
	ArrayList<Integer> newN = new ArrayList<Integer>();
	for (int n : N) newN.add(n);
	int m = P.size();
	int[] colour = new int[m];
	numberSort(C,P,P,colour);
	for (int i=m-1;i>=0;i--){
	    if (C.size() + colour[i] <= maxSize) return;
	    int v = P.get(i);
	    C.add(v);
	    if (disjointFrom(v, newN)){
		ArrayList<Integer> newP = new ArrayList<Integer>(i);
		for (int j=0;j<=i;j++){
		    int u = P.get(j);
		    if (A[u][v]) newP.add(u);
		}
		if (newP.isEmpty() && C.size() > maxSize) saveSolution(C);
		if (!newP.isEmpty()) expand(C,newP,newN);
	    }
	    C.remove(C.size()-1);
	    P.remove(i);
            newN.add(v);
	}
    }

    boolean disjointFrom(int v, ArrayList<Integer> N) {
        for (int n : N)
            if (A[v][n])
                return true;
        return false;
    }
}
